#ifndef _MLX90640_I2C_Driver_H_
#define _MLX90640_I2C_Driver_H_

#include <stdint.h>
#include "debug.h"
#include "MLX90640_API.h"

//IO
#define SDA_IN()  {GPIOA->CFGLR &= ~(0xF << 28); GPIOA->CFGLR |= (3 << 28);}  // 
#define SDA_OUT() {GPIOA->CFGLR &= ~(0xF << 28); GPIOA->CFGLR |= (1 << 28);}  // 

#define GPIO_PORT_I2C   GPIOA
#define RCC_I2C_PORT    RCC_APB2Periph_GPIOA
#define I2C_SCL_PIN     GPIO_Pin_9          /* ӵSCLʱߵGPIO */
#define I2C_SDA_PIN     GPIO_Pin_15         /* ӵSDAߵGPIO */

#define IIC_SCL_HIGH()  GPIO_PORT_I2C->BSHR = I2C_SCL_PIN               /* SCL = 1 */
#define IIC_SCL_LOW()   GPIO_PORT_I2C->BCR = I2C_SCL_PIN                /* SCL = 0 */

#define IIC_SDA_HIGH()  GPIO_PORT_I2C->BSHR = I2C_SDA_PIN               /* SDA = 1 */
#define IIC_SDA_LOW()   GPIO_PORT_I2C->BCR = I2C_SDA_PIN                /* SDA = 0 */

#define IIC_SDA_READ()  ((GPIO_PORT_I2C->INDR & I2C_SDA_PIN) != 0)       /* SDA״̬ */

void MLX90640_I2CInit(void);
int  MLX90640_I2CRead(uint8_t slaveAddr,uint16_t startAddress, uint16_t nMemAddressRead, uint16_t *data);
int  MLX90640_I2CWrite(uint8_t slaveAddr,uint16_t writeAddress, uint16_t data);
void MLX90640_I2CFreqSet(int freq);
int I2CScanDevices(void);

#endif
